/***************************************************************************
* A(lchemist) Game, a game about taking elements from the surrounding and throwing to a your enemies.
* Copyright (C) 2012  Sven Stamm
* 
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
* 
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
* 
* You should have received a copy of the GNU General Public License
* along with this program.  If not, see <http://www.gnu.org/licenses/>.
***************************************************************************/
package arakash.lpc.Map;

import org.newdawn.slick.GameContainer;
import org.newdawn.slick.state.StateBasedGame;

import arakash.lpc.base.MyGame;
import arakash.lpc.components.Component;
import arakash.lpc.components.ComponentList;

public class CameraControlComponent extends Component {

	private int deadzone;
	
	public CameraControlComponent(int Deadzone){
		this(ComponentList.CAMERA_CONTROL_COMPONENT, Deadzone);
	}
	
	public CameraControlComponent(int type, int Deadzone){
		super(type);
		this.deadzone = Deadzone;
	}
	
	@Override
	public void update(GameContainer gc, StateBasedGame sbgame, int delta) {
		int relativePosX = (int) (owner.getPosition().x - MyGame.getCameraPosX()); 
		int relativePosY = (int) (owner.getPosition().y - MyGame.getCameraPosY());
		float speed = (float)Integer.parseInt(owner.getProperty("speed"))/100;
		
		//only move the Camera if the Player is in the deadzone and the Camera doesn't go outside the Map
		if( relativePosX > (MyGame.getWIDTH() - deadzone) && MyGame.getCameraPosX()+MyGame.getWIDTH() < GameMap.CurrentMap.getMapTotalWidth()){
			MyGame.setCameraPosX(MyGame.getCameraPosX() + delta *speed);
		}		
		if(relativePosX <  deadzone && MyGame.getCameraPosX() > 2){
			MyGame.setCameraPosX(MyGame.getCameraPosX() - delta * speed);
		}
		if(relativePosY > (MyGame.getHEIGHT() - deadzone) && MyGame.getCameraPosY() + MyGame.getHEIGHT() < GameMap.CurrentMap.getMapTotalHeight()){
			MyGame.setCameraPosY(MyGame.getCameraPosY() + delta *speed);
		}
		if(relativePosY < deadzone && MyGame.getCameraPosY() > 2){
			MyGame.setCameraPosY(MyGame.getCameraPosY() - delta*speed);
		}
		if(relativePosY < 0)
			relativePosY = 0;
		if(relativePosX < 0)
			relativePosX = 0;
	}

	@Override
	public void cleanup() {
		// TODO Auto-generated method stub
		
	}

}
