/***************************************************************************
* A(lchemist) Game, a game about taking elements from the surrounding and throwing to a your enemies.
* Copyright (C) 2012  Sven Stamm
* 
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
* 
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
* 
* You should have received a copy of the GNU General Public License
* along with this program.  If not, see <http://www.gnu.org/licenses/>.
***************************************************************************/
package arakash.lpc.base;

import org.newdawn.slick.GameContainer;
import org.newdawn.slick.Graphics;
import org.newdawn.slick.Image;
import org.newdawn.slick.Input;
import org.newdawn.slick.SlickException;
import org.newdawn.slick.SpriteSheet;
import org.newdawn.slick.gui.AbstractComponent;
import org.newdawn.slick.gui.ComponentListener;
import org.newdawn.slick.gui.MouseOverArea;
import org.newdawn.slick.state.StateBasedGame;

import TWLSlick.BasicTWLGameState;

public class MainMenuState extends BasicTWLGameState {

	Image Background = null;
	SpriteSheet Text = null;
	MouseOverArea[] MOarea = new MouseOverArea[4];
	Image Pointer = null;
	
	/*
	 * simple Menu platzierung, der erste Eintrag kommt bei MenuStart, der 2. bei MenuStart+MenuEntryheight etc.
	 * wird wohl noch überarbeitet werden müssen, aber fürs erste reichts. :)
	 */
	int MenuStartX = 70;			
	int MenuStartY = 300;
	int MenuEntryheight = 100;
	int num_MenuEntrys= 4;
	
	int pointerPos = 0;
	int pointeroffsetX = 10;	//wert um den der Pointer nach links verschoben wird.
	
    /** The ID given to this state */ 
    public static final int ID = 1;  
	
    /** The game holding this state */ 
    private StateBasedGame game;  
    
	@Override
	public void enter(GameContainer arg0, StateBasedGame arg1)
			throws SlickException {
		super.enter(arg0, arg1);
		ResourceManager.setBackgroundMusic("mysticalTheme");
	}
	
	@Override
	public void keyPressed(int key, char c) {
		/*
		 * Falls öfters die pointer Pos geändert werden muss, in Funktion auslagern!
		 */
		if(key == Input.KEY_W || key == Input.KEY_UP){
			if(pointerPos > 0){
				pointerPos--;
			}
			else
				pointerPos = num_MenuEntrys -1;
		}
		
		if(key == Input.KEY_S || key == Input.KEY_DOWN){
			if(pointerPos < num_MenuEntrys-1){
			pointerPos++;
			}
			else
				pointerPos = 0;
		}
		
		if(key == Input.KEY_ENTER){
			switch(pointerPos){
			case 0: //game.enterState(10); break;
			case 1: ResourceManager.playSound("accept"); game.enterState(2); break; //Networking
			case 2: break;
			case 3: game.getContainer().exit(); break;
			}
		}
	}

	@Override
	public void keyReleased(int arg0, char arg1) {
		// TODO Auto-generated method stub

	}

	@Override
	public int getID() {
		// TODO Auto-generated method stub
		return ID;
	}

	@Override
	public void init(GameContainer arg0, StateBasedGame arg1)
			throws SlickException {
		// TODO Auto-generated method stub
		this.game = arg1;
		Text = new SpriteSheet("img/MenuText0.png", 300, 50);
		Background = new Image("img/MenuBackground.png");
		Pointer = new Image("img/pointer.png");
		ResourceManager.init();
		//start game
		Image i = Text.getSubImage(0, 0);
		MOarea[0] = new MouseOverArea(	arg0, i, MenuStartX, MenuStartY,
										i.getWidth(), i.getHeight(), new ComponentListener() {
											@Override
											public void componentActivated(AbstractComponent arg0) {
												// go to singleplayer
												//game.enterState(10);
										}
										});
		//Network
		i = Text.getSubImage(0, 1);
		MOarea[1] = new MouseOverArea(	arg0, i, MenuStartX, MenuStartY + MenuEntryheight,
										i.getWidth(), i.getHeight(), new ComponentListener() {
											@Override
											public void componentActivated(AbstractComponent arg0) {
												// TODO Auto-generated method stub
												ResourceManager.playSound("accept");
												game.enterState(2);
											}
										});
		
		//Options
		i=Text.getSubImage(0, 2);
		MOarea[2] = new MouseOverArea(	arg0, i, MenuStartX, MenuStartY + 2*MenuEntryheight,
										i.getWidth(), i.getHeight(), new ComponentListener() {
											@Override
											public void componentActivated(AbstractComponent arg0) {
												// TODO Auto-generated method stub
												
											}
										});
		//Exit
		i=Text.getSubImage(0, 3);
		MOarea[3] = new MouseOverArea(	arg0, i, MenuStartX, MenuStartY + 3*MenuEntryheight,
										i.getWidth(), i.getHeight(), new ComponentListener() {
											@Override
											public void componentActivated(AbstractComponent arg0) {
												// TODO Auto-generated method stub
												game.getContainer().exit();
											}
										});
	}

	@Override
	public void leave(GameContainer arg0, StateBasedGame arg1)
			throws SlickException {
		// TODO Auto-generated method stub

	}

	@Override
	public void render(GameContainer arg0, StateBasedGame arg1, Graphics arg2)
			throws SlickException {
		// TODO Auto-generated method stub
		Background.draw(0,0);
		//Das könnte man auch schön in ne for schleife packen ...
		MOarea[0].render(arg0, arg2);
		MOarea[1].render(arg0, arg2);
		MOarea[2].render(arg0, arg2);
		MOarea[3].render(arg0, arg2);
		
		Pointer.draw(MenuStartX- pointeroffsetX - Pointer.getWidth(), MenuStartY + pointerPos*MenuEntryheight);
	}

	@Override
	public void update(GameContainer arg0, StateBasedGame arg1, int arg2)
			throws SlickException {
		// TODO Auto-generated method stub

	}
}
