/***************************************************************************
* A(lchemist) Game, a game about taking elements from the surrounding and throwing to a your enemies.
* Copyright (C) 2012  Sven Stamm
* 
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
* 
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
* 
* You should have received a copy of the GNU General Public License
* along with this program.  If not, see <http://www.gnu.org/licenses/>.
***************************************************************************/

package arakash.lpc.base;


import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.net.InetAddress;
import java.net.URL;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Properties;
import java.util.Random;

import org.newdawn.slick.AppGameContainer;
import org.newdawn.slick.GameContainer;
import org.newdawn.slick.Graphics;
import org.newdawn.slick.SlickException;
import org.newdawn.slick.Sound;
import org.newdawn.slick.state.StateBasedGame;


import TWLSlick.TWLStateBasedGame;
import arakash.lpc.entity.Entity;
import arakash.lpc.network.client.ClientNetworkState;

import com.esotericsoftware.kryonet.Client;

/**
 * 
 * @author sven
 *	Music: http://opengameart.org/content/no-ressonace-image
 * 
 */
public class MyGame extends TWLStateBasedGame{

	private static float 	CameraPosX = 0;
	private static float 	CameraPosY = 0;
	private static int		WIDTH = 1024;
	private static int 		HEIGHT = 768;
	
	private static Client	client = null;
	private static int		requestId = 0;
	private static int		lastresponseId = 0;
	
	public static InetAddress	address;
	
//	public static ArrayList<Entity>	EntityList = new ArrayList<Entity>();
//	public static ArrayList<Entity>	EntityDeleteList=new ArrayList<Entity>();
	
	public static HashMap<String, String> props = new HashMap<String, String>();
	
	public static Random randGenerator = new Random();
	
	public static Properties Options = new Properties();
	
	public static String	PlayerName;
	
	public MyGame(){
		super("AGame");
	}

	@Override
	public void initStatesList(GameContainer arg0) throws SlickException {
		// TODO Auto-generated method stub
		addState(new MainMenuState());
//		addState(new inGameState());
		addState(new ClientNetworkState());
		addState(new NetworkMenuState());
		addState(new GameOverState());
	}
	
	public static void main(String[] args){
		try{
			try {
				Options.load(new FileInputStream("Options.properties"));
			} catch (FileNotFoundException e) {
				e.printStackTrace();
			} catch (IOException e) {
				e.printStackTrace();
			}
			
			AppGameContainer gc = new AppGameContainer(new MyGame());
			gc.setDisplayMode(WIDTH, HEIGHT, false);
			gc.setAlwaysRender(true);
			gc.setMinimumLogicUpdateInterval(10);
			gc.setClearEachFrame(false);
			gc.setVSync(true);
			gc.setTargetFrameRate(60);
			gc.start();
		} catch(SlickException e){
			System.err.println("Slick Exception in Main State!");
		}
	}

	public static float getCameraPosX() {
		return CameraPosX;
	}

	public static void setCameraPosX(float cameraPosX) {
		CameraPosX = cameraPosX;
	}

	public static float getCameraPosY() {
		return CameraPosY;
	}

	public static void setCameraPosY(float cameraPosY) {
		CameraPosY = cameraPosY;
	}

	public static int getWIDTH() {
		return WIDTH;
	}

	public static int getHEIGHT() {
		return HEIGHT;
	}

	public static Client getClient() {
		return client;
	}

	public static void setClient(Client client) {
		MyGame.client = client;
	}

	public static int getRequestId() {
		return requestId;
	}

	/**
	 * returns the request Id and then increments it by 1
	 * @return the MyGame.requestId
	 */
	public static int getRequestIdThenInc(){
		int ret = requestId;
		requestId +=1;
		return ret;
	}
	
	public static void setRequestId(int requestId) {
		MyGame.requestId = requestId;
	}

	public static int getLastresponseId() {
		return lastresponseId;
	}

	public static void setLastresponseId(int lastresponseId) {
		MyGame.lastresponseId = lastresponseId;
	}

	@Override
	protected URL getThemeURL() {
		// TODO Auto-generated method stub
		return MyGame.class.getResource("/myTheme.xml");
	}
}
