/***************************************************************************
* A(lchemist) Game, a game about taking elements from the surrounding and throwing to a your enemies.
* Copyright (C) 2012  Sven Stamm
* 
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
* 
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
* 
* You should have received a copy of the GNU General Public License
* along with this program.  If not, see <http://www.gnu.org/licenses/>.
***************************************************************************/

package arakash.lpc.base;

import java.net.InetAddress;
import java.net.UnknownHostException;


import org.newdawn.slick.GameContainer;
import org.newdawn.slick.Graphics;
import org.newdawn.slick.Image;
import org.newdawn.slick.Input;
import org.newdawn.slick.SlickException;
import org.newdawn.slick.state.StateBasedGame;

import de.matthiasmann.twl.Button;
import de.matthiasmann.twl.EditField;
import de.matthiasmann.twl.Label;
import de.matthiasmann.twl.TextWidget;

import TWLSlick.BasicTWLGameState;
import TWLSlick.RootPane;


public class NetworkMenuState extends BasicTWLGameState {

//	private TextField AddressField;
//	private Font font;
	private Image background;
    public static final int ID = 2;
//    SpriteSheet Text;
//	private MouseOverArea[] MOareas = new MouseOverArea[2];

    int changeState = -1;
    
    private StateBasedGame game;
	
    private Button 		connectBtn;
    private Button 		cancelBtn;
    private EditField 	adressField;
    private Label		IPLabel;
    private EditField	nameField;
    private Label		nameLabel;
    
    TextWidget adressText;
    @Override
    protected RootPane createRootPane() {
        RootPane rp = super.createRootPane();
        System.out.println("set theme... " + rp.getTheme());
        rp.setTheme("myTheme");
        
        IPLabel = new Label();
        IPLabel.setTheme("label");
        rp.add(IPLabel);
        
        nameLabel=new Label("Your Name: ");
        nameLabel.setTheme("label");
        rp.add(nameLabel);
        
        adressField = new EditField();
        adressField.setTheme("TextField");
        adressText = new TextWidget();
        adressText.setTheme("/label");
        adressField.add(adressText);
        rp.add(adressField);
        
        connectBtn = new Button("connect");
        connectBtn.setTheme("myButton");
        connectBtn.addCallback(new Runnable() {
            public void run() {
            	MyGame.PlayerName = nameField.getText();
            	try {
					MyGame.address = InetAddress.getByName(adressField.getText());
				} catch (UnknownHostException e) {
					e.printStackTrace();
				}
                changeState = 20;
            }
        });
        rp.add(connectBtn);
        
        cancelBtn = new Button();
        cancelBtn.setTheme("myButton");
        cancelBtn.setText("cancel");
        cancelBtn.addCallback(new Runnable(){
        	public void run(){
        		game.enterState(1);
        	}
        });
        rp.add(cancelBtn);
        
        nameField = new EditField();
        nameField.setTheme("TextField");
        rp.add(nameField);
                
        return rp;
    }
    
    @Override
    protected void layoutRootPane() {
        connectBtn.adjustSize();
        connectBtn.setPosition(300, 650);
        
        cancelBtn.adjustSize();
        cancelBtn.setPosition(500, 650);
        
        
        adressField.setText("127.0.0.1");
        adressField.adjustSize();
        adressField.setPosition(MyGame.getWIDTH()/2-adressField.getWidth()/2, 200);
        IPLabel.adjustSize();
        IPLabel.setPosition(adressField.getX()-40, 220);
        IPLabel.setText("IP : ");
        
        nameField.setText(MyGame.Options.getProperty("playername"));
        nameField.setPosition(adressField.getX(), adressField.getY()+adressField.getHeight()+10);
        nameField.adjustSize();
        
        nameLabel.adjustSize();
        nameLabel.setPosition(nameField.getX()-nameLabel.getWidth()-10, nameField.getY()+30);
    }
    
    @Override
	public void keyPressed(int key, char c) {
    	if( key == Input.KEY_ESCAPE){
    		game.enterState(1); //back to main Menu!
    	}
    	if (key == Input.KEY_ENTER){
    		MyGame.PlayerName = nameField.getText();
    		try {
				MyGame.address = InetAddress.getByName(adressField.getText());
			} catch (UnknownHostException e) {
				e.printStackTrace();
			}
    		ResourceManager.playSound("accept");
    		game.enterState(20);
    	}
    }
    
	@Override
	public void init(GameContainer gc, StateBasedGame tgame)
			throws SlickException {
		// TODO Auto-generated method stub
		background = new Image("img/NetworkBg.png");
//		font = new AngelCodeFont("data/SlickFont.fnt", "data/SlickFont_00.tga");
/*		AddressField = new TextField(gc, font, 300, 100, 300, 50, new ComponentListener() {
			@Override
			public void componentActivated(AbstractComponent arg0) {
				// TODO Auto-generated method stub
				
			}
		});
		AddressField.setBorderColor(Color.white);
		AddressField.setText("127.0.0.1"); */
		this.game = tgame;
//		Text = new SpriteSheet("img/NetworkMenuText0.png", 300, 50);
/*		MOareas[0] = new MouseOverArea(	gc, Text.getSubImage(0, 1), 300, 500, 
										Text.getSubImage(0,1).getWidth(), Text.getSubImage(0, 1).getHeight(), 
										new ComponentListener() {
											@Override
											public void componentActivated(AbstractComponent arg0) {
												// TODO Auto-generated method stub
												try {
													if(game instanceof MyGame){
														ResourceManager.playSound("accept");
													MyGame.address = InetAddress.getByName(AddressField.getText());
													game.enterState(20);
													}
													else
													System.err.println("NetworkMenuState: game is not Instance of MyGame!");
												} catch (UnknownHostException e) {
													// TODO Auto-generated catch block
													e.printStackTrace();
												}
											}
										});
		
		MOareas[1] = new MouseOverArea( gc, Text.getSubImage(0, 2), 500, 500,
										Text.getSubImage(0, 2).getWidth(), Text.getSubImage(0, 2).getHeight(),
										new ComponentListener() {
											@Override
											public void componentActivated(AbstractComponent arg0) {
												// TODO Auto-generated method stub
												game.enterState(1); //back to main Menu
											}
										});*/
	}

	@Override
	public void render(GameContainer gc, StateBasedGame game, Graphics g)
			throws SlickException {
		// TODO Auto-generated method stub
		background.draw(0,0);
//		AddressField.render(gc, g);
//		Text.getSubImage(0, 0).draw(AddressField.getX() -50, AddressField.getY());

//		MOareas[0].render(gc, g);
//		MOareas[1].render(gc, g);
	}

	@Override
	public void update(GameContainer arg0, StateBasedGame arg1, int arg2)
			throws SlickException {
		// TODO Auto-generated method stub
		if(changeState > 0){
			game.enterState(changeState);
			changeState = -1;
		}
		
	}

	@Override
	public int getID() {
		// TODO Auto-generated method stub
		return ID;
	}

}
