/***************************************************************************
* A(lchemist) Game, a game about taking elements from the surrounding and throwing to a your enemies.
* Copyright (C) 2012  Sven Stamm
* 
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
* 
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
* 
* You should have received a copy of the GNU General Public License
* along with this program.  If not, see <http://www.gnu.org/licenses/>.
***************************************************************************/
package arakash.lpc.components;

import org.newdawn.slick.GameContainer;
import org.newdawn.slick.state.StateBasedGame;

import arakash.lpc.entity.Entity;

/**
 * a basic Component. Component get added to Entites to fullfill specific roles.
 * @author sven
 *
 */
public abstract class Component {

	protected int ID;
	protected int type;
	transient protected Entity owner;

	public Component(int type){
		this.type = type;
		//register the Component on the ComponentManager
		ComponentManager.registerNewComponent(this);
	}
	
	public int getID() {
		return ID;
	}
	
	public int getType(){
		return this.type;
	}
	
	public void setOwnerEntity(Entity owner){
		this.owner = owner;
	}
	
	public Entity getOwnerEntity(){
		return this.owner;
	}
	
	public void onAdd(Entity owner){
		
	}
	
	public abstract void update(GameContainer gc, StateBasedGame sbgame, int delta);
	
	/**
	 * Used to clear the Memory from Images and other per-game created Fields.
	 */
	public abstract void cleanup();
}
