/***************************************************************************
* A(lchemist) Game, a game about taking elements from the surrounding and throwing to a your enemies.
* Copyright (C) 2012  Sven Stamm
* 
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
* 
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
* 
* You should have received a copy of the GNU General Public License
* along with this program.  If not, see <http://www.gnu.org/licenses/>.
***************************************************************************/
package arakash.lpc.components;

import org.newdawn.slick.geom.Shape;

import arakash.lpc.entity.Entity;
import arakash.lpc.network.server.GameServer;
import arakash.lpc.network.server.PropertyChangeUpdate;

public class DebuffonTouchComponent extends touchComponent {

	private String	propName;
	private float debuffPercent;
	private String debuffName;
	private int debuffTime;
	
	//TODO: Debuffs should be percentual. 
	//TODO: TOO MUCH FUCKING PARAMETERS
	public DebuffonTouchComponent(Shape hitboxshape,
			int offsetX, int offsetY, HitBoxType targetHbType, String propName, float debuffPercent, String debuffName, int debuffTimeMS) {
		this(ComponentList.LETHAL_DEBUFF_COMPONENT, hitboxshape, null, offsetX, offsetY, targetHbType, propName, debuffPercent, debuffName, debuffTimeMS);
	}
	
	public DebuffonTouchComponent(int compType, Shape hitboxshape,
			HitBoxType type, int offsetX, int offsetY, HitBoxType targetHbType, String propName, float debuffPercent, String debuffName, int debuffTimeMS){
		super(compType, hitboxshape, null, offsetX, offsetY, targetHbType);
		this.propName = propName;
		this.debuffPercent = debuffPercent;
		this.debuffName = debuffName;
		this.debuffTime = debuffTimeMS;
	}

	@Override
	public void onTouch(HitBox hitbox, int delta) {
		//super.onTouch(hitbox, delta);
		if(hitbox.getOwnerEntity().getProperty("debuff") == null || !hitbox.getOwnerEntity().getProperty("debuff").contains(debuffName)){
			Entity ent = hitbox.getOwnerEntity();
			ent.addComponent(new PropertyChangeComponent(debuffTime, "debuff", debuffName, PropertyChangeComponent.PROP_CONCAT));
			if(ent.getProperty(propName) == null){
				System.out.println("Property is null! " + propName);
				return;
			}
			int newStat = (int) (Integer.parseInt(ent.getProperty(propName)) * debuffPercent);
			ent.addComponent(new PropertyChangeComponent(debuffTime, propName, ""+newStat, PropertyChangeComponent.PROP_REPLACE));
			
			PropertyChangeUpdate pcu = new PropertyChangeUpdate();
			pcu.setEntityID(ent.getID());
			pcu.setPropertyName(new String[]{propName}); pcu.setPropertyValue(new String[]{""+newStat});
			GameServer.addUpdate(pcu);
		}
	}
	
	@Override
	public void cleanup(){
		
	}
	
	public String getPropName() {
		return propName;
	}

	public void setPropName(String propName) {
		this.propName = propName;
	}
}
