/***************************************************************************
* A(lchemist) Game, a game about taking elements from the surrounding and throwing to a your enemies.
* Copyright (C) 2012  Sven Stamm
* 
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
* 
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
* 
* You should have received a copy of the GNU General Public License
* along with this program.  If not, see <http://www.gnu.org/licenses/>.
***************************************************************************/
package arakash.lpc.components;


import org.newdawn.slick.GameContainer;
import org.newdawn.slick.Graphics;
import org.newdawn.slick.Image;
import org.newdawn.slick.SlickException;
import org.newdawn.slick.geom.Vector2f;
import org.newdawn.slick.state.StateBasedGame;

import arakash.lpc.base.MyGame;

public class ImageRenderComponent extends RenderComponent {
	Image image;
	
	public ImageRenderComponent( int type, Image image)
	{
		super(type);
		this.image = image;
	}
	public ImageRenderComponent(Image image){
		this(ComponentList.IMAGE_RENDER_COMPONENT, image);
	}

	@Override
	public void render(GameContainer gc, StateBasedGame sb, Graphics gr) {
		Vector2f pos = owner.getPosition();
		if(!(sb instanceof MyGame)){
			System.err.print("WRONG GAME?!");
			System.exit(-1);
		}


		image.draw(pos.x - MyGame.getCameraPosX(), pos.y - MyGame.getCameraPosY());
	}

	@Override
	public void cleanup() {
		try {
			this.image.destroy();
		} catch (SlickException e) {
			e.printStackTrace();
		}
	}
	@Override
	public void update(GameContainer gc, StateBasedGame sbgame, int delta) {
		// TODO Auto-generated method stub
		
	}
}