/***************************************************************************
* A(lchemist) Game, a game about taking elements from the surrounding and throwing to a your enemies.
* Copyright (C) 2012  Sven Stamm
* 
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
* 
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
* 
* You should have received a copy of the GNU General Public License
* along with this program.  If not, see <http://www.gnu.org/licenses/>.
***************************************************************************/
package arakash.lpc.components;

import org.newdawn.slick.GameContainer;
import org.newdawn.slick.geom.Rectangle;
import org.newdawn.slick.geom.Vector2f;
import org.newdawn.slick.state.StateBasedGame;

import arakash.lpc.entity.Entity;

public class InterpolComponent extends MovementComponent{
	
	Vector2f oldPos = new Vector2f(0,0);
	Vector2f oldPosSafe=new Vector2f(0,0);
	int		 Setspeed;
	private boolean standing;
	
	public InterpolComponent(int speed){
		this(ComponentList.INTERPOL_COMPONENT,speed);
	}
	
	public InterpolComponent(int type,int speed) {
		super(type, new Rectangle(0, 0, 10,10), null, 0, 0);
		
		this.Setspeed = speed;
	}

	@Override
	public void onAdd(Entity owner){
		((Rectangle) this.collisionShape).setWidth(owner.width);
		((Rectangle) this.collisionShape).setHeight(owner.height);
		oldPosSafe=owner.getPosition();
		oldPos = owner.getPosition();
	}
	
	@Override
	public void update(GameContainer gc, StateBasedGame sbgame, int delta) {
		//init
		if(owner.getProperty("speed") == null){
			owner.setOrAddProperty("speed", ""+Setspeed);
			oldPosSafe = owner.getPosition();
			oldPos = owner.getPosition();
			standing = true;
		}
		
		//Old safe Pos, oldupdatePos
		//vergleiche oldupdatePos mit der jetzigen, falls ein großer Sprung, mehr als von einem Update, nehme an, dass ein Playerupdate vorgekommen ist
		// und vergleiche Old safe mit dieser Position. dann setzt OldSafe auf diese und beginne von vorne.
		
		//check if there was a irregular jump -> probably a Entity Update!
		if(Math.abs(owner.getPosition().x - oldPos.x) > speed * delta || Math.abs(owner.getPosition().y - oldPos.y) > speed*delta){
			if((int) oldPosSafe.x == (int) owner.getPosition().x && (int) oldPosSafe.y == (int) owner.getPosition().y){
				standing = true;
				//System.out.println("standing ist true!");
			}
			else{
				standing = false;
			}
			oldPosSafe = owner.getPosition();
		}
		
		if(!standing)
			super.update(gc, sbgame, delta);
			
		oldPos = owner.getPosition();
	}

	@Override
	public void cleanup() {
		super.cleanup();
	}
}
