/***************************************************************************
* A(lchemist) Game, a game about taking elements from the surrounding and throwing to a your enemies.
* Copyright (C) 2012  Sven Stamm
* 
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
* 
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
* 
* You should have received a copy of the GNU General Public License
* along with this program.  If not, see <http://www.gnu.org/licenses/>.
***************************************************************************/
package arakash.lpc.components;

import org.newdawn.slick.GameContainer;
import org.newdawn.slick.geom.Shape;
import org.newdawn.slick.state.StateBasedGame;

import arakash.lpc.entity.Entity;

/**
 * Logic -> should always be on the Server
 * changes or adds Property on owner:
 * damage
 * gets or checks Property from Entity:
 * death
 * @author sven
 *
 */
public class LethalTouchComponent extends touchComponent{

	/**
	 * how much damage does this per millisecond(!) of hit do.
	 */
	int 	damage= 1;
	int		tickInterval = 100;
	int		tickTimer = 0;
	
	public LethalTouchComponent( Shape hitboxshape,
			 int offsetX, int offsetY, HitBoxType targetHbType, int damage){
		this(ComponentList.LETHAL_TOUCH_COMPONENT, hitboxshape,null, offsetX, offsetY, targetHbType, damage);
	}
	
	public LethalTouchComponent( Shape hitboxshape,
			int offsetX, int offsetY, HitBoxType targetHbType) {
		this(ComponentList.LETHAL_TOUCH_COMPONENT, hitboxshape, null, offsetX, offsetY, targetHbType,1);
	}
	
	public LethalTouchComponent(int compType, Shape hitboxshape,
			HitBoxType type, int offsetX, int offsetY,	HitBoxType targetHbType, int damage) {
		super(compType, hitboxshape, type, offsetX, offsetY, targetHbType);
		this.damage = damage;
	}
	
	@Override
	public void update(GameContainer gc, StateBasedGame sbgame, int delta) {
		if(tickTimer >= tickInterval){
			tickTimer = 0;
			super.update(gc, sbgame, delta);
		}
		tickTimer += delta;
	}
	
	@Override
	public void onTouch(HitBox hitbox, int delta) {
		//TODO: change to EntityUpdate
		//TODO: make a onHit() abstract method or smth.
		if(hitbox.getOwnerEntity().getProperty("death")!=null && hitbox.getOwnerEntity().getProperty("death").equals("1")){
			return;
		}
		
		//check if the entity is has a owner itself (like a spell)
		if(owner.getProperty("ownerID") != null)
			hitbox.getOwnerEntity().setOrAddProperty("lastHit", owner.getProperty("ownerID"));
			
		System.out.println("HIT!HIT!HIT!" + this.getHitBoxes(hbtype).size());
		Entity entity = hitbox.getOwnerEntity();
		//TODO: option a) damage is all done here: substract damage from health
		//		option b) damage is done by a seperate component, which could also reduce it by armor etc.
		//!!!	hab mich mal für option 2 entschieden, sieht flexibler aus.
		String EntDamage = entity.getProperty("damage");
		int newdmg;
		if(EntDamage == null || EntDamage.equals("0"))
			newdmg = damage;
		else
			newdmg = Integer.parseInt(EntDamage) + damage;
		
		entity.setOrAddProperty("damage", ""+newdmg);
	}
}
