/***************************************************************************
* A(lchemist) Game, a game about taking elements from the surrounding and throwing to a your enemies.
* Copyright (C) 2012  Sven Stamm
* 
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
* 
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
* 
* You should have received a copy of the GNU General Public License
* along with this program.  If not, see <http://www.gnu.org/licenses/>.
***************************************************************************/
package arakash.lpc.components;

import org.newdawn.slick.GameContainer;
import org.newdawn.slick.Graphics;
import org.newdawn.slick.Input;
import org.newdawn.slick.SlickException;
import org.newdawn.slick.SpriteSheet;
import org.newdawn.slick.geom.Vector2f;
import org.newdawn.slick.state.StateBasedGame;

import arakash.lpc.Map.GameMap;
import arakash.lpc.base.LPCAnimation;
import arakash.lpc.base.MyGame;
import arakash.lpc.base.ResourceManager;
import arakash.lpc.entity.Entity;
import arakash.lpc.entity.EntityManager;
import arakash.lpc.network.client.MagicAbsorbUpdate;
import arakash.lpc.network.client.MagicAttackUpdate;

/**
 * Magic Components handles all Magic things. absorbing, storing and shooting Magics (and sending your actions to the server)
 * @author sven
 *
 */
public class MagicComponent extends RenderComponent {

	int			ActionKey;
	short		Waterelements = 0;
	short		Fireelements = 0;
	short		Earthelements = 0;
	
	//EnergieSpeicher [5] = Entity an Player Pos mit ImageComp
	//Aktion: Zaubern 
	
	public MagicComponent(int type, int ActionKey){
		super(type);
		this.ActionKey = ActionKey;
	}

	@Override
	public void update(GameContainer gc, StateBasedGame sbgame, int delta){
		// TODO Auto-generated method stub
		Input input = gc.getInput();
		if(owner.getProperty("death") != null && owner.getProperty("death").equals("1")){
			return;
		}
		if(input.isMousePressed(Input.MOUSE_LEFT_BUTTON)){
			/**
			 * TODO: this whole section should be transferred to the Server
			 */
			
			//können sich vllt. bei einem ... NetworkManager (?) registrieren für spezielle Klassen? <- aber meistens sinds nur verschiedene Entities
			int TilePosX = (int) (input.getMouseX()+MyGame.getCameraPosX())/GameMap.CurrentMap.getTileWidth();
			int TilePosY = (int) (input.getMouseY()+MyGame.getCameraPosY())/GameMap.CurrentMap.getTileHeight();
			Vector2f TilePos = new Vector2f(TilePosX, TilePosY);
			if(GameMap.CurrentMap.elementalTilePos.get(TilePos) == null){
				System.out.println("found no Element for the Tile" + " " + TilePos + " | " + GameMap.CurrentMap.getTileId(TilePosX, TilePosY, 2) + " " + GameMap.CurrentMap.getTileId(TilePosX, TilePosY, 3));
				//GameMap.CurrentMap.setTileId(TilePosX, TilePosY, 2, 56);
				return;
			}
			System.out.println("Element for Tile: " + GameMap.CurrentMap.elementalTilePos.get(TilePos));
			//spawn new Entity for Animation		
			if(GameMap.CurrentMap.elementalTilePos.get(TilePos).equals("fire") && Fireelements <=5){
				System.out.println("found fire!");
				Fireelements++;
				Earthelements=0;
				Waterelements=0;
			}
			else if(GameMap.CurrentMap.elementalTilePos.get(TilePos).equals("earth") && Earthelements <=5){
				System.out.println("found earth!");
				Earthelements++;
				Fireelements=0;
				Waterelements=0;
			}
			else if(GameMap.CurrentMap.elementalTilePos.get(TilePos).equals("water") && Waterelements <= 5){
				System.out.println("found water!");
				Waterelements++;
				Fireelements=0;
				Earthelements=0;
			}
			else {
				System.out.println("found no Element for the Tile" + " " + TilePos + " | " + GameMap.CurrentMap.getTileId(TilePosX, TilePosY, 2) + " " + GameMap.CurrentMap.getTileId(TilePosX, TilePosY, 3));
				return;
			}

			System.out.println("sending him my update!");
			MagicAbsorbUpdate mau = new MagicAbsorbUpdate();
			mau.setTargetX((int) (input.getMouseX()+MyGame.getCameraPosX()));
			mau.setTargetY((int) (input.getMouseY()+MyGame.getCameraPosY()));
			MyGame.getClient().sendUDP(mau);
		}
		
		if(input.isKeyPressed(ActionKey) || input.isMousePressed(Input.MOUSE_RIGHT_BUTTON)){
			int PosX = (int) (input.getMouseX()+MyGame.getCameraPosX());
			int PosY = (int) (input.getMouseY()+MyGame.getCameraPosY());
			System.out.println("BÄÄÄM! ATTACK");
			if(Waterelements > 0){
				Waterelements--;
				MagicAttackUpdate mau = new MagicAttackUpdate();
				mau.setPosX(PosX);
				mau.setPosY(PosY);
				if(owner.getProperty("waterlvl")==null || owner.getProperty("waterlvl").equals("0")){
					mau.setMagicName("iceSpike");
				}
				else if(owner.getProperty("waterlvl").equals("1"))
					mau.setMagicName("tripleIceSpikes");
				else{
					mau.setMagicName("torrenTacle");
				}
				
				MyGame.getClient().sendUDP(mau);
			}
			else if(Fireelements > 0){
				Fireelements--;
				MagicAttackUpdate mau = new MagicAttackUpdate();
				mau.setPosX(PosX);
				mau.setPosY(PosY);
				if(owner.getProperty("firelvl")==null || owner.getProperty("firelvl").equals("0")){
					mau.setMagicName("fire");
				}
				else if(owner.getProperty("firelvl").equals("1")){
					mau.setMagicName("explosion");
				}
				else{
					mau.setMagicName("fireTornado");
				}
				
				MyGame.getClient().sendUDP(mau);
			}
			else if(Earthelements > 0){
				Earthelements--;
				MagicAttackUpdate mau = new MagicAttackUpdate();
				mau.setPosX(PosX);
				mau.setPosY(PosY);
				if(owner.getProperty("earthlvl")==null || owner.getProperty("earthlvl").equals("0")){
					mau.setMagicName("earthSpike");
				}
				else if(owner.getProperty("earthlvl").equals("1"))
					mau.setMagicName("tripleEarthSpikes");
				else
					mau.setMagicName("tornado");
				
				MyGame.getClient().sendUDP(mau);
			}
		}
	}

	@Override
	public void cleanup() {
		// TODO Auto-generated method stub
	}

	@Override
	public void render(GameContainer gc, StateBasedGame sbgame, Graphics g) {
		// TODO Auto-generated method stub
		LPCAnimation icons = ResourceManager.getAnimationFromResName("elementIcons");
		int iconToDraw = -1;
		int amount = 0;
		if(Waterelements!=0){
			iconToDraw = 0;
			amount = Waterelements;
		}
		if(Earthelements!= 0){
			iconToDraw = 1;
			amount = Earthelements;
		}
		if(Fireelements!=0){
			iconToDraw = 2;
			amount = Fireelements;
		}
		
		for(int i = 0; i< amount; i++){
			icons.getSpriteSheet().getSprite(0,iconToDraw).draw(owner.getPosition().x+i*10+i - MyGame.getCameraPosX(),
																owner.getPosition().y+owner.height+5 - MyGame.getCameraPosY());
		}	
	}

}
