/***************************************************************************
* A(lchemist) Game, a game about taking elements from the surrounding and throwing to a your enemies.
* Copyright (C) 2012  Sven Stamm
* 
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
* 
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
* 
* You should have received a copy of the GNU General Public License
* along with this program.  If not, see <http://www.gnu.org/licenses/>.
***************************************************************************/
package arakash.lpc.components;

import org.newdawn.slick.GameContainer;
import org.newdawn.slick.state.StateBasedGame;

import arakash.lpc.network.server.GameServer;
import arakash.lpc.network.shared.MessageUpdate;

public class NPCPingComponent extends Component{
	int timeInterval;
	int timer;
	
	public NPCPingComponent(int timeInterval){
		super(0);
		this.timeInterval = timeInterval;
		this.timer = 0;
	}

	@Override
	public void update(GameContainer gc, StateBasedGame sbgame, int delta) {
		timer += delta;
		if(timer >= timeInterval){
			MessageUpdate mu = new MessageUpdate();
			mu.setMsg("Quick! To the SafePoint!");
			mu.setOwnerID(owner.getID());
			mu.setPing(true);
			mu.setDuration(timeInterval);
			GameServer.addUpdate(mu);
			timer -= timeInterval;
		}
		
	}

	@Override
	public void cleanup() {
		// TODO Auto-generated method stub
		
	}
}
