/***************************************************************************
* A(lchemist) Game, a game about taking elements from the surrounding and throwing to a your enemies.
* Copyright (C) 2012  Sven Stamm
* 
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
* 
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
* 
* You should have received a copy of the GNU General Public License
* along with this program.  If not, see <http://www.gnu.org/licenses/>.
***************************************************************************/
package arakash.lpc.components;

import org.newdawn.slick.GameContainer;
import org.newdawn.slick.Graphics;
import org.newdawn.slick.geom.Circle;
import org.newdawn.slick.state.StateBasedGame;

import arakash.lpc.base.MyGame;

public class PingComponent extends RenderComponent {
	protected int TTL;
	private int pausetime;
	private boolean repeat;
	protected float Timecounter = 0;
	protected int		PingRadius;	//this could go in a seperate Class
	protected Circle	pingCircle;
	
	public PingComponent(int tTL, int pausetime, boolean repeat) {
		this(ComponentList.PING_COMPONENT, tTL, pausetime, repeat);
	}
	
	public PingComponent(int type, int tTL, int pausetime, boolean repeat) {
		super(type);
		TTL = tTL;
		this.pausetime = pausetime;
		this.repeat = repeat;
		this.pingCircle = new Circle(0, 0, 10);
		Timecounter = TTL;
	}

	@Override
	public void render(GameContainer gc, StateBasedGame sbgame, Graphics g) {
		if(Timecounter > 0){
			pingCircle.setCenterX(owner.getPosition().x+owner.width/2 - MyGame.getCameraPosX());
			pingCircle.setCenterY(owner.getPosition().y+owner.height/2 - MyGame.getCameraPosY());
			g.draw(pingCircle);
		}
		
	}

	@Override
	public void update(GameContainer gc, StateBasedGame sbgame, int delta) {
		if(Timecounter < 0){
			if(repeat){
				Timecounter -= delta;
				if(Timecounter < (-1) * pausetime){
					Timecounter= TTL;
					pingCircle.radius = 10;
				}
			}
			else
				this.owner.componentsToDelete.add(this);
		}
		
		if(Timecounter> 0){
			Timecounter -= delta;
			pingCircle.setRadius(pingCircle.getRadius()+delta);
		}
	}

	@Override
	public void cleanup() {
		
	}

}
