/***************************************************************************
* A(lchemist) Game, a game about taking elements from the surrounding and throwing to a your enemies.
* Copyright (C) 2012  Sven Stamm
* 
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
* 
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
* 
* You should have received a copy of the GNU General Public License
* along with this program.  If not, see <http://www.gnu.org/licenses/>.
***************************************************************************/
package arakash.lpc.components;

import org.newdawn.slick.GameContainer;
import org.newdawn.slick.Input;
import org.newdawn.slick.state.StateBasedGame;

import arakash.lpc.base.MyGame;
import arakash.lpc.network.shared.MessageUpdate;

/**
 * send a 'Ping' Update to the Server, when the User presses the specified Key (default KEY_1)
 * @author sven
 *
 */
public class PlayerPingComponent extends Component {

	public PlayerPingComponent(){
		this(ComponentList.PING_COMPONENT);
	}
	
	public PlayerPingComponent(int type) {
		super(type);
	}

	@Override
	public void update(GameContainer gc, StateBasedGame sbgame, int delta) {
		// TODO Auto-generated method stub
		if(owner.getProperty("death") != null && owner.getProperty("death").equals("1"))
			return;
		
		Input input = gc.getInput();
		if(input.isKeyPressed(Input.KEY_1)){
			MessageUpdate mu = new MessageUpdate();
			mu.setOwnerID(owner.getID());
//			mu.setMsg(MyGame.Options.getProperty("pingMessage"));
			mu.setMsg("  !  ");
			mu.setPing(true);
			mu.setDuration(800);
			MyGame.getClient().sendUDP(mu);
		}
		else if (input.isKeyPressed(Input.KEY_2)){
			MessageUpdate mu = new MessageUpdate();
			mu.setOwnerID(owner.getID());
//			mu.setMsg(MyGame.Options.getProperty("pingMessage"));
			mu.setMsg("   ?   ");
			mu.setPing(true);
			mu.setDuration(800);
			MyGame.getClient().sendUDP(mu);
		}
	}

	@Override
	public void cleanup() {
		// TODO Auto-generated method stub

	}
}
