/***************************************************************************
* A(lchemist) Game, a game about taking elements from the surrounding and throwing to a your enemies.
* Copyright (C) 2012  Sven Stamm
* 
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
* 
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
* 
* You should have received a copy of the GNU General Public License
* along with this program.  If not, see <http://www.gnu.org/licenses/>.
***************************************************************************/
package arakash.lpc.components;


import org.newdawn.slick.geom.Circle;

import arakash.lpc.base.QuestManager;
import arakash.lpc.entity.Entity;
import arakash.lpc.network.server.GameServer;
import arakash.lpc.network.server.PropertyChangeUpdate;
import arakash.lpc.network.shared.MessageUpdate;

public class QuestGiverComponen extends touchComponent {
	int questID;
	
	public QuestGiverComponen(int questID){
		this(ComponentList.QUEST_GIVER_COMPONENT, questID);
	}
	
	public QuestGiverComponen(int type, int questID) {
		
		super(new Circle(0, 0, 100), null, 0, 0, HitBoxType.PLAYER);
		this.questID = questID;
	}

	@Override
	public void onAdd(Entity owner){

	}

	@Override
	public void onTouch(HitBox touchedHB, int delta) {
		if(touchedHB.getOwnerEntity().getProperty("currentQuest")!= null && !touchedHB.getOwnerEntity().getProperty("currentQuest").equals(""))
			return;
		
		touchedHB.getOwnerEntity().setOrAddProperty("currentQuest", ""+questID);
		PropertyChangeUpdate pcu = new PropertyChangeUpdate();
		pcu.setEntityID(touchedHB.getOwnerEntity().getID());
		pcu.setPropertyName(new String[]{"currentQuest"});
		pcu.setPropertyValue(new String[]{""+questID});
		GameServer.addUpdate(pcu);
		
		MessageUpdate mu =  new MessageUpdate();
		mu.setMsg(QuestManager.getFullText(questID));
		mu.setOwnerID(owner.getID());
		GameServer.addUpdate(mu);
	}
}
