/***************************************************************************
* A(lchemist) Game, a game about taking elements from the surrounding and throwing to a your enemies.
* Copyright (C) 2012  Sven Stamm
* 
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
* 
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
* 
* You should have received a copy of the GNU General Public License
* along with this program.  If not, see <http://www.gnu.org/licenses/>.
***************************************************************************/
package arakash.lpc.components;

import org.newdawn.slick.geom.Circle;
import org.newdawn.slick.geom.Shape;

import arakash.lpc.components.HitBox.HitBoxType;
import arakash.lpc.entity.Entity;

public abstract class QuestTargetComponent extends touchComponent {

	int questID;

	public QuestTargetComponent( int questID) {
		this(ComponentList.QUEST_TARGET_COMPONENT, questID);
	}
	
	public QuestTargetComponent(int compType, int questID) {
		super(new Circle(0, 0, 50), null, 0, 0, HitBoxType.PLAYER);
		this.questID = questID;
	}

	@Override
	public void onTouch(HitBox touchedHB, int delta) {
		//see if the Player has you as active Quest,
		if(touchedHB.getOwnerEntity().getProperty("currentQuest") != null && touchedHB.getOwnerEntity().getProperty("currentQuest").equals(""+questID)){
			onQuestComplete(touchedHB.getOwnerEntity());
		}
		
		//mark it as done,
		//disappear?
		//abstract on QuestComplete?
		//additional circumstances, like kill X beasts, protect it for X seconds; guard him, kill Player; plunder Grave
	}
	
	public abstract void onQuestComplete(Entity player);
}
