/***************************************************************************
* A(lchemist) Game, a game about taking elements from the surrounding and throwing to a your enemies.
* Copyright (C) 2012  Sven Stamm
* 
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
* 
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
* 
* You should have received a copy of the GNU General Public License
* along with this program.  If not, see <http://www.gnu.org/licenses/>.
***************************************************************************/
package arakash.lpc.components;


import org.newdawn.slick.GameContainer;
import org.newdawn.slick.Graphics;
import org.newdawn.slick.state.StateBasedGame;

import arakash.lpc.base.MyGame;

import arakash.lpc.components.ComponentList;

public class TextComponent extends RenderComponent {
	
	protected String Text;
	protected int TTL;
	private int pausetime;
	private boolean repeat;
	protected float Timecounter;

	
	public TextComponent(String Text, int TTL, boolean repeat,int pausetime){
		this(ComponentList.TEXT_COMPONENT, Text, TTL, repeat, pausetime);
	}
	
	public TextComponent(int type, String Text, int TTL, boolean repeat,int pausetime) {
		super(type);
		
		this.Text = Text;
		this.TTL = TTL*1000;
		this.repeat = repeat;
		this.pausetime = pausetime;
		this.Timecounter = this.TTL;
	}

	@Override
	public void render(GameContainer gc, StateBasedGame sbgame, Graphics g) {
		if(Timecounter > 0){
		g.drawString(Text, owner.getPosition().x - MyGame.getCameraPosX(), owner.getPosition().y-40-MyGame.getCameraPosY());
		}
	}

	@Override
	public void update(GameContainer gc, StateBasedGame sbgame, int delta) {

		if(Timecounter < 0){
			if(repeat){
				if(Timecounter < (-1) * pausetime){
					Timecounter= TTL;
				}
			}
			else
				this.owner.componentsToDelete.add(this);
		}
		
			Timecounter -= delta;
	}

	@Override
	public void cleanup() {
		// TODO Auto-generated method stub
	}
}
