/***************************************************************************
* A(lchemist) Game, a game about taking elements from the surrounding and throwing to a your enemies.
* Copyright (C) 2012  Sven Stamm
* 
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
* 
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
* 
* You should have received a copy of the GNU General Public License
* along with this program.  If not, see <http://www.gnu.org/licenses/>.
***************************************************************************/
package arakash.lpc.components;

import org.newdawn.slick.Color;
import org.newdawn.slick.GameContainer;
import org.newdawn.slick.Graphics;
import org.newdawn.slick.ShapeFill;
import org.newdawn.slick.geom.Rectangle;
import org.newdawn.slick.geom.Shape;
import org.newdawn.slick.geom.Vector2f;
import org.newdawn.slick.state.StateBasedGame;

import arakash.lpc.base.MyGame;

/**
 * shows Healthbars on top of the entitys
 * uses Entity Properties:
 * health, maxhealth
 * @author sven
 */
public class healthbarComponent extends RenderComponent {

	Rectangle	healthBarShape;
	//TODO type here.
	public healthbarComponent(){
		this(ComponentList.HEALTHBAR_COMPONENT);
	}
	public healthbarComponent(int type){
		super(type);
		this.healthBarShape = new Rectangle(0, 0, 5, 5);
	}
	
	@Override
	public void render(GameContainer gc, StateBasedGame sbgame, Graphics g) {

		//TODO make a boolean hideOnFullHealth (or smth)
		if(!owner.getProperty("health").equals(owner.getProperty("maxhealth"))){
		g.fill(healthBarShape, new ShapeFill() {
			@Override
			public Vector2f getOffsetAt(Shape arg0, float arg1, float arg2) {
				return new Vector2f(0,0);
			}
			@Override
			public Color colorAt(Shape arg0, float arg1, float arg2) {
				return Color.red;
			}
		});
		}
	}

	@Override
	public void update(GameContainer gc, StateBasedGame sbgame, int delta) {
		this.healthBarShape.setLocation(new Vector2f(owner.getPosition().x - MyGame.getCameraPosX(), owner.getPosition().y -MyGame.getCameraPosY()));
		//need: maxhealth!
		int Health = Integer.parseInt(owner.getProperty("health"));
		int maxHealth=Integer.parseInt(owner.getProperty("maxhealth"));
		float newWidth = ((float)Health/maxHealth) * owner.width;
		this.healthBarShape.setWidth(newWidth);
	}

	@Override
	public void cleanup() {
		// TODO Auto-generated method stub

	}

}
