/***************************************************************************
* A(lchemist) Game, a game about taking elements from the surrounding and throwing to a your enemies.
* Copyright (C) 2012  Sven Stamm
* 
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
* 
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
* 
* You should have received a copy of the GNU General Public License
* along with this program.  If not, see <http://www.gnu.org/licenses/>.
***************************************************************************/
package arakash.lpc.components;

import org.newdawn.slick.geom.Shape;

import arakash.lpc.base.LPCAnimation;
import arakash.lpc.base.ResourceManager;
import arakash.lpc.entity.Entity;
import arakash.lpc.entity.EntityManager;
import arakash.lpc.network.server.GameServer;
import arakash.lpc.network.server.PropertyChangeUpdate;

public class scrollPickupComponent extends touchComponent{
	public static final int SCROLL_WATER = 0;
	public static final int SCROLL_EARTH = 1;
	public static final int SCROLL_FIRE 	= 2;
	
	int scrollType;
	
	public scrollPickupComponent(Shape hitboxshape,
			int offsetX, int offsetY, HitBoxType targetHbType, int scrollType){
		this(ComponentList.SCROLLPICKUP_COMPONENT, hitboxshape, offsetX, offsetY,targetHbType,scrollType);
	}
	
	public scrollPickupComponent(int compType, Shape hitboxshape,
			int offsetX, int offsetY, HitBoxType targetHbType, int scrollType) {
		super(compType, hitboxshape, null, offsetX, offsetY,targetHbType);
		
		this.scrollType = scrollType;
	}

	@Override
	public void onTouch(HitBox touchedHB, int delta) {
		System.out.println("uuh you touched my tralala");
		Entity ent = touchedHB.getOwnerEntity();
		PropertyChangeUpdate pcu = new PropertyChangeUpdate();
		pcu.setEntityID(touchedHB.getOwnerEntity().getID());
		String[] PropNames = new String[2];
		String[] PropValues= new String[2];
		if(scrollType == SCROLL_WATER){
			addMagicLvl(touchedHB.getOwnerEntity(), "waterlvl");
			addMagicLvl(touchedHB.getOwnerEntity(), "level");
			PropNames[0] = "waterlvl"; PropValues[0] = ent.getProperty("waterlvl");
		}
		else if(scrollType == SCROLL_EARTH){
			addMagicLvl(touchedHB.getOwnerEntity(), "earthlvl");
			addMagicLvl(touchedHB.getOwnerEntity(), "level");
			PropNames[0] = "earthlvl"; PropValues[0] = ent.getProperty("earthlvl");
		}
		else if(scrollType == SCROLL_FIRE){
			addMagicLvl(touchedHB.getOwnerEntity(), "firelvl");
			addMagicLvl(touchedHB.getOwnerEntity(), "level");
			PropNames[0] = "firelvl"; PropValues[0] = ent.getProperty("firelvl");
		} 
		PropNames[1] = "level"; PropValues[1] = ent.getProperty("level");
		System.out.println("level of Entity " + ent.getID() + " " + ent.getProperty("level"));
		pcu.setPropertyName(PropNames);
		pcu.setPropertyValue(PropValues);
		GameServer.addUpdate(pcu);

		//TODO this whole part is nearly the same as in DestroyOnDeathComponent
		pcu = new PropertyChangeUpdate();
		PropNames = new String[3]; PropValues = new String[3];
		PropNames[0] = "resourceName"; PropValues[0] = "magicAbsorb";
		LPCAnimation anim = ResourceManager.Animations.get("magicAbsorb");
		PropNames[1] = "selfdestruct"; PropValues[1] =""+ anim.getTimeForOneAnim()*anim.getSpriteSheet().getHorizontalCount();
		PropNames[2] = "soundResource"; PropValues[2] = "waterBubble";
		pcu.setEntityID(owner.getID());
		pcu.setPropertyName(PropNames);
		pcu.setPropertyValue(PropValues);
		GameServer.addUpdate(pcu);
		//set resource to death resource (MagicAbsorb)
		//set DIR
		//set selfdestruct to anim.getTimeForOneAnim()*anim.getSpriteSheet().getHorizontalCount()
		
		//destroy ALL EVIDENCE!
		EntityManager.curManager.deregisterEntity(owner.getID());
		/*for(PlayerClient pc : GameServer.clients){
			EntityManagerInterface em = ObjectSpace.getRemoteObject(pc.getClientConnection(), 42, EntityManagerInterface.class);
			((RemoteObject) em).setNonBlocking(true, true);
			em.deregisterEntity(owner.getID());
		}*/
		//couldn't this also be implemented by a few Propertys? (for example selfdestructComp. checks the selfdestruct property
	}
	
	protected void addMagicLvl(Entity e, String propertyName){
		int magicLvl = 0;
		if(e.getProperty(propertyName) == null || e.getProperty(propertyName).equals("0")){
			e.setOrAddProperty(propertyName, "1");
			return;
		}
		else{
			magicLvl = Integer.parseInt(e.getProperty(propertyName));
			e.setOrAddProperty(propertyName, "" + (magicLvl+1));
		}
	}
}
