/***************************************************************************
* A(lchemist) Game, a game about taking elements from the surrounding and throwing to a your enemies.
* Copyright (C) 2012  Sven Stamm
* 
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
* 
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
* 
* You should have received a copy of the GNU General Public License
* along with this program.  If not, see <http://www.gnu.org/licenses/>.
***************************************************************************/
package arakash.lpc.components;

import org.newdawn.slick.GameContainer;
import org.newdawn.slick.state.StateBasedGame;

import arakash.lpc.entity.EntityManager;

/**
 * In order for the selfDestructComponent to Work, the entity <b>has</b> to register itself with the EntityManager
 * @author sven
 *
 */
public class selfdestructComponent extends Component {
	int timeInMsToSelfdestruct= 0;
	int timer = 0;
	
	public selfdestructComponent(int selfdestructTimeMS){
		this(ComponentList.SELFDESTRUCT_COMPONENT, selfdestructTimeMS);
	}
	
	public selfdestructComponent(int type,int selfdestructTimeMS) {
		super(type);
		this.timeInMsToSelfdestruct = selfdestructTimeMS;
	}

	@Override
	public void update(GameContainer gc, StateBasedGame sbgame, int delta) {
		if(!owner.isPropertyZeroOrNull("selfdestruct") && timeInMsToSelfdestruct != Integer.parseInt(owner.getProperty("selfdestruct"))){
			timeInMsToSelfdestruct = Integer.parseInt(owner.getProperty("selfdestruct"));
		}
		timer += delta;
		if(timer >= timeInMsToSelfdestruct){
			owner.cleanup();
			EntityManager.curManager.deregisterEntity(owner.getID());
		}
	}

	@Override
	public void cleanup() {
		// TODO Auto-generated method stub

	}

}
