/***************************************************************************
* A(lchemist) Game, a game about taking elements from the surrounding and throwing to a your enemies.
* Copyright (C) 2012  Sven Stamm
* 
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
* 
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
* 
* You should have received a copy of the GNU General Public License
* along with this program.  If not, see <http://www.gnu.org/licenses/>.
***************************************************************************/
package arakash.lpc.components;

import org.newdawn.slick.GameContainer;
import org.newdawn.slick.geom.Shape;
import org.newdawn.slick.state.StateBasedGame;

public abstract class touchComponent extends HitBox {
	HitBoxType hbtype;
	
	public touchComponent(Shape hitboxshape, HitBoxType type,
			int offsetX, int offsetY, HitBoxType targetHBType){
		this(ComponentList.TOUCH_COMPONENT, hitboxshape, type, offsetX, offsetY, targetHBType);
	}
	
	public touchComponent(int compType, Shape hitboxshape, HitBoxType type,
			int offsetX, int offsetY, HitBoxType targetHBType) {
		super(compType, hitboxshape, type, offsetX, offsetY);
		this.hbtype = targetHBType;
	}

	@Override
	public void update(GameContainer gc, StateBasedGame sbgame, int delta) {
		super.update(gc, sbgame, delta);
		for(HitBox hitbox : this.getHitBoxes(hbtype)){
			if(this.collisionShape.intersects(hitbox.collisionShape)){
				this.onTouch(hitbox, delta);
			}
		}
	}
	
	public abstract void onTouch(HitBox touchedHB, int delta);
}
