/***************************************************************************
* A(lchemist) Game, a game about taking elements from the surrounding and throwing to a your enemies.
* Copyright (C) 2012  Sven Stamm
* 
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
* 
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
* 
* You should have received a copy of the GNU General Public License
* along with this program.  If not, see <http://www.gnu.org/licenses/>.
***************************************************************************/
package arakash.lpc.components;

import org.newdawn.slick.GameContainer;
import org.newdawn.slick.Input;
import org.newdawn.slick.geom.Shape;
import org.newdawn.slick.state.StateBasedGame;

import arakash.lpc.entity.Entity;

//TODO Property files
public class walkingComponent extends MovementComponent{
	
	/**
	 * the walking of a Player. His speed is based on the "speed" Property entry of his owner, if not, it falls back to a default value
	 * checks or gets Property of entity:
	 * death 
	 * @param hitboxshape
	 * @param offsetX
	 * @param offsetY
	 */
	public walkingComponent(Shape hitboxshape, int offsetX, int offsetY){
		this(ComponentList.WALKING_COMPONENT, hitboxshape, offsetX, offsetY);
	}
	
	public walkingComponent(int type, Shape shape, int offsetX, int offsetY) {
		super(type, shape, null, offsetX, offsetY);
	}

	@Override
	public void update(GameContainer gc, StateBasedGame sbgame, int delta) {
		if(owner.getProperty("death")!= null && owner.getProperty("death").equals("1"))
			return;		//owner is dead, so no Movement for you

		Input input = gc.getInput();
		boolean keyPressed = false;
		
		
        if(input.isKeyDown(Input.KEY_A))
        {
        		owner.setDIR(Entity.DIR_LEFT);
        		keyPressed = true;
        }
 
        else if(input.isKeyDown(Input.KEY_D))
        {      	
        		owner.setDIR(Entity.DIR_RIGHT);
        		keyPressed = true;
        }
 
        else if(input.isKeyDown(Input.KEY_W)){
        	owner.setDIR(Entity.DIR_UP);
        	keyPressed = true;
        }
        
        else if(input.isKeyDown(Input.KEY_S)){
        	owner.setDIR(Entity.DIR_DOWN);
        	keyPressed = true;
        }
   		
        //only walk when a key was pressed, TODO: this is a little bit hacky
        if(keyPressed)
        super.update(gc, sbgame, delta);
	}

	@Override
	public void cleanup() {
		// TODO Auto-generated method stub
		super.cleanup();
	}

}
