/***************************************************************************
* A(lchemist) Game, a game about taking elements from the surrounding and throwing to a your enemies.
* Copyright (C) 2012  Sven Stamm
* 
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
* 
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
* 
* You should have received a copy of the GNU General Public License
* along with this program.  If not, see <http://www.gnu.org/licenses/>.
***************************************************************************/
package arakash.lpc.entity;

import java.util.ArrayList;

import arakash.lpc.base.EntityManagerInterface;

public class EntityManager implements EntityManagerInterface{
	public static EntityManager curManager;
	
	public ArrayList<Entity> Entities = new ArrayList<Entity>();
	private ArrayList<Integer> entitiesToDelete = new ArrayList<Integer>();
	
	public EntityManager(){};
	
	public static EntityManager createNewManager(){
		if(curManager != null)
			curManager.clearEntities();
		EntityManager em = new EntityManager();
		curManager = em;
		return em;
	}
	
	public void registerNewEntity(Entity e){
	//TODO inconstistent with the other Methods to create Entitys
		//curEntityID++;
		Entities.add(e);
	}
	
	public void deregisterEntity(int EntityID){
		entitiesToDelete.add(EntityID);
	}

	public void finishEntityDeletion(){
		while(entitiesToDelete.size() > 0){
			if(Entities.size() == 0){
				System.out.println("we have a serious problem of Entity mismatch here, doc!");
				entitiesToDelete.clear();
			}
			for(int i = 0; i < Entities.size(); i++){
				if(Entities.get(i).getID() == entitiesToDelete.get(0)){
					Entities.get(i).cleanup();
					Entities.remove(i);
					System.out.println("successfully removed Entity! " + Entities.size());
					entitiesToDelete.remove(0);
					break;
				}
				else if(i == Entities.size()-1){
					//didn't find the element to remove... just removing from list
					int e = entitiesToDelete.remove(0);
					System.out.println("removed EntityID " + e + " but got no Entity with that ID in my Entity List");
				}
			}
		}
		
	}
	
	public ArrayList<Entity> getEntites() {
		return Entities;
	}
	public void clearEntities(){
		for(int i = 0; i <Entities.size(); i++){
			entitiesToDelete.add(Entities.get(i).getID());
		}
		finishEntityDeletion();
		entitiesToDelete.clear();
		Entities.clear();
	}
}
